﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;

namespace HeuristicLab.Problems.Instances {
  public class Transformer {
    public static double[,] Transformation(List<List<double>> data) {
      if (!data.All(x => x.Count.Equals(data.First().Count)))
        throw new ArgumentException("Can't create jagged array.");
      double[,] values = new double[data.First().Count, data.Count];
      for (int i = 0; i < values.GetLength(0); i++) {
        for (int j = 0; j < values.GetLength(1); j++) {
          values[i, j] = data[j][i];
        }
      }
      return values;
    }
  }
}
